/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.payroll.dao.MKintaiKeisanDao;
import jp.mosp.payroll.dto.MKintaiKeisanDto;

import jp.mosp.system.vo.KeisanInformationCardVo;

public class KeisanInformationCardAction extends MosPAction {

	// コマンド
	private static final String CMD_KEISAN_INFO_SHOW 		= "S1100";	//表示
	private static final String CMD_KEISAN_INFO_UPDATE	= "S1108";	//更新

	// フィールド
	protected MKintaiKeisanDto dto;

	/**
	 * コンストラクタ
	 */
	public KeisanInformationCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// 計算管理権限確認
		confirmCalculateAuth();
		// VOの取得及び設定
		KeisanInformationCardVo vo = getInitVo();
		init(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_KEISAN_INFO_SHOW)) {
			// 表示
			show(vo);
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_KEISAN_INFO_UPDATE)){
			// 更新
			vo.setParams(request);
			update(vo);
			// 表示
			show(vo);
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 初期VOインスタンス取得
	 * @return	初期VO
	 */
	protected KeisanInformationCardVo getInitVo() {
		return new KeisanInformationCardVo();
	}

	/**
	 * Action初期処理
	 * @param vo			対象VO
	 * @throws Exception
	 */
	protected void init(KeisanInformationCardVo vo) throws Exception {
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先の準備
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MKintaiKeisanDto ? (MKintaiKeisanDto)obj : null;
		// プルダウンのセット
		vo.aryPltMonth 			= util.getMonthArray();
		vo.aryPltDays 			= util.getDayArray();
		vo.aryPltCompleteFlag 	= setPltCompleteFlag();
	}

	/**
	 * 設定項目検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	protected void show(KeisanInformationCardVo vo) throws Exception {
		// DAOの準備
		MKintaiKeisanDao dao = new MKintaiKeisanDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		dto = dao.findForCalc();
		if (chkExistDto(dto)) {
			//	dtoがあったら、dtoをVoにセットする。
			vo.setFields(dto);
		} else {
			// なかったら、設定された年月をそれぞれの年月フィールドにセットする。
			// 勤怠計算月設定、給与計算日設定
			vo.setFields(getCalcMonth(), getCalcPayment(getCalcMonth()));
		}
		// モード設定
		vo.setMode(KeisanInformationCardVo.MODE_UPDATE);
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void update(KeisanInformationCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MKintaiKeisanDao dao = new MKintaiKeisanDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		if (dto == null) {
			dto = new MKintaiKeisanDto();
		}
		// 更新する前にdtoが存在するかどうかをチェック
		MKintaiKeisanDto currentDto = dao.findForUpdate(String.valueOf(dto.getKTNen()));
		if (chkExistDto(currentDto)) {
			// 削除
			dao.delete(currentDto);
		}
		vo.setDtoFields(dto);
		// 登録	
		dao.insert(dto);
		// DTOの再取得
		MKintaiKeisanDto retDto = dao.findForKey(String.valueOf(dto.getKTNen()));		
		chkUpdate(retDto);
		// セッション用DTOにセット
		dto = retDto;
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		// コミット
		commit();			
	}	

	/**
	 * 計算状況フラグプルダウン
	 * @return	aryPltCompleteFlag
	 * @throws Exception
	 */
	protected String[][] setPltCompleteFlag() throws Exception {
		String[][] aryPltCompleteFlag = new String[2][2];
		aryPltCompleteFlag[0][0] = CommonConst.NUM_ATT_CALCULATE_COMPLETE_FLAG_OFF;
		aryPltCompleteFlag[0][1] = CommonConst.NAM_ATT_CALCULATE_COMPLETE_FLAG_OFF;
		aryPltCompleteFlag[1][0] = CommonConst.NUM_ATT_CALCULATE_COMPLETE_FLAG_ON;
		aryPltCompleteFlag[1][1] = CommonConst.NAM_ATT_CALCULATE_COMPLETE_FLAG_ON;
		return aryPltCompleteFlag;
	}

}
